#include <bits/stdc++.h>

using namespace std;

long long x[1005],y[1005],r[1005];
vector<vector<int>> g(1005);
int deg[1005];
bool vis[1005];
bool boja[1005];

bool bipart=true;

vector<int> kurcina;
void dfs(int p, bool kojaboja)
{
    if (vis[p])
    {
        if (kojaboja!=boja[p]) bipart=false;
        return;
    }
    vis[p]=true;
    boja[p]=kojaboja;
    kurcina.push_back(p);

    for (auto it : g[p]) dfs(it,!kojaboja);
}

int main() 
{
    ios::sync_with_stdio(false); cin.tie(0);
    
    int n; cin>>n;
    for (int i=0;i<n;i++) cin>>x[i]>>y[i]>>r[i];

    for (int i=0;i<n;i++)
        for (int j=0;j<i;j++)
        {
            if ((long long)(x[i]-x[j])*(x[i]-x[j]) + (long long)(y[i]-y[j])*(y[i]-y[j]) == (long long)(r[i]+r[j])*(r[i]+r[j]))
            {
                deg[i]++;
                deg[j]++;
                g[i].push_back(j);
                g[j].push_back(i);
                //cout<<"MARS U PICKU MATERINU "<<i<<" "<<j<<endl;
            }
        }

    for (int i=0;i<n;i++) if (!vis[i])
    {
        bipart=true;
        kurcina.clear();
        dfs(i,0);

        //cout<<"JEBEM TI MATER GLUPAVU "<<bipart<<endl;

        if (bipart)
        {
            int picka=0;
            int kurac=0;
            for (auto p : kurcina)
            {
                if (boja[p]) picka++;
                else kurac++;
            }

            if (kurac!=picka) return cout<<"YES\n",0;
        }
    }

    cout<<"NO\n";

    return 0;
}